# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"
program Scl

  use sep

  implicit none

  integer :: n1, n2, n3, i, j, k, crop1, crop2
  real :: o1, d1, o2, d2, o3, d3

  real, dimension(:), allocatable :: enorm
  real, dimension(:,:), allocatable :: sol
  real, dimension(:,:), allocatable :: data

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2)
  call from_history("o2", o2)
  call from_history("d2", d2)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  call from_param("crop1", crop1)
  call from_param("crop2", crop2)

  call to_history("n1", n3)
  call to_history("o1", o3)
  call to_history("d1", d3)
  call to_history("n2", 1)
  call to_history("o2", 0.)
  call to_history("d2", 1.)
  call to_history("n3", 1)
  call to_history("o3", 0.)
  call to_history("d3", 1.)


  allocate(data(n1,n2), sol(n1,n2), enorm(n3))

  call sep_read(sol, "sol")

  sol(1:crop1,:) = 0.0
  sol(n1-crop1+1:n1,:) = 0.0
  sol(:,1:crop2) = 0.0
  sol(:,n2-crop2+1:n2) = 0.0

  sol = sol/sqrt(sum(sol*sol))

  do k=1,n3
    data = 0.0
    call sreed('in', data, 4*size(data))
    data(1:crop1,:) = 0.0
    data(n1-crop1+1:n1,:) = 0.0
    data(:,1:crop2) = 0.0
    data(:,n2-crop2+1:n2) = 0.0

    data = data/sqrt(sum(data*data))

    enorm(k) = sqrt(sum((data-sol)*(data-sol)))
  enddo

  call sep_write(enorm)

  call sep_close()

end program
